#version 130
#extension GL_EXT_gpu_shader4 : enable
// the version and open GL extension
// should be the first line of the shader
/////////////////////////////////////////////////////////////////////////////////
// Weird Fractal 6Mod01.fsh  by   AieKick
//https://www.shadertoy.com/view/XtlXzn
//Licence : Creative Commons Attribution-ShareAlike 4.0
//http://creativecommons.org/licences/by-sa/4.0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform sampler2D texture3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

// Created by Stephane Cuillerdier - Aiekick/2015
// License Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.

//another variation of my Weird Fractal 4 : https://www.shadertoy.com/view/MtsGzB

mat3 getRotYMat(float a){return mat3(cos(a),0.,sin(a),0.,1.,0.,-sin(a),0.,cos(a));}

float map(in vec3 p, in vec3 q, inout vec3 r, inout float m)
{
	float d = 0.;
    for (int j = 0; j < 3 ; j++)
    	r=max(r.zyx*=r*=r*=r=mod(q*m+1.,2.)-1.,r.yzx),
        d=max(d,(0.12 -length(r))/m),
        m*=1.1;
    return d;
}

//void mainImage( out vec4 fragColor, in vec2 fragCoord )
///////////////////////////////////////////////////////////////////////////////// 
// need to convert this from a void to a function and call it by adding
// a void main(void) { to the end of the shader
// what type of variable will the function return?, it is a color and needs to be a vec4
// change void to vec4 
//void MainImage(out vec4 fragColor, in vec2 fragCoord) 
vec4 mainImage( out vec4 fragColor, in vec2 fragCoord )
{
	vec2 s = iResolution.xy;
    float t = iTime*.2, c,d,m,f=0.;
    vec3 p=vec3((2.*fragCoord.xy-s)/s.x,1.),r=p-p,q=r;
    p*=getRotYMat(-t);
    q.zx += 10.+vec2(sin(t),cos(t))*3.;
    for (float i=1.; i>0.; i-=.001) 
    {
    	c=d=0.,m=1.;
        f+=0.01;
        d = map(p,q,r,m);
        q+=p*d;
        c = i;
        if(d<1e-5) break;
   	}
    
    vec3 eps = vec3( 0.001, 0., 0. );
    vec3 nor = normalize(vec3(
    	map(p,q+eps.xyy,r,m) - map(p,q-eps.xyy,r,m),
        map(p,q+eps.yxy,r,m) - map(p,q-eps.yxy,r,m),
        map(p,q+eps.yyx,r,m) - map(p,q-eps.yyx,r,m) ));

    float k = dot(r,r+.15);
    vec3 col= vec3(1.,k,k/c)-vec3(0.7 ,0.8, 0);
    fragColor.rgb = col/f;
    gl_FragColor.a = length(gl_FragColor.rgb);

/////////////////////////////////////////////////////////////////////////////////
//the function needs to return a value. 
//it needs to be a vec4
//we will return the varable fragColor 
// usual place for fragColor = vec4( color, 1.0 ); bring the } down below
return fragColor; 
}

///////////////////////////////////////////////////////////////////////////////// 
void main(void) { // this will be run for every pixel of gl_FragCoord.xy
vec4 vTexCoord = gl_TexCoord[0];
vec4 fragColor = vec4(1.0); // initialize variable fragColor as a vec4 
vec4 cc = mainImage(fragColor, gl_FragCoord.xy); // call function mainImage and assign the return vec4 to cc
gl_FragColor = vec4(cc) * gl_Color; // set the pixel to the value of vec4 cc  and..
}

// ..uses the values of any Color: or Opacity:
// clauses (and any Animate clauses applied to these properties) 
// appearing in the Sprite, Quad or other node invoking the shader 
// in the .scn file.

